Bug 195758 - Delay WebProcess launch until a load is triggered in a Web view
Summary: Delay WebProcess launch until a load is triggered in a Web view
Status: RESOLVED FIXED
Alias: None
Product: WebKit
Classification: Unclassified
Component: WebKit2 (show other bugs)
Version: WebKit Nightly Build
Hardware: Unspecified Unspecified
: P2 Normal
Assignee: Chris Dumez
URL:
Keywords: InRadar
Depends on: 195747 195922 195951 195954
Blocks: 196119
  Show dependency treegraph
 
Reported: 2019-03-14 13:38 PDT by Chris Dumez
Modified: 2019-06-05 05:08 PDT (History)
11 users (show)

See Also:


Attachments
WIP Patch (19.77 KB, patch)
2019-03-14 16:07 PDT, Chris Dumez
no flags Details | Formatted Diff | Diff
Patch (26.86 KB, patch)
2019-03-14 16:26 PDT, Chris Dumez
no flags Details | Formatted Diff | Diff
Patch (26.86 KB, patch)
2019-03-14 16:39 PDT, Chris Dumez
no flags Details | Formatted Diff | Diff
Patch (27.12 KB, patch)
2019-03-14 16:44 PDT, Chris Dumez
no flags Details | Formatted Diff | Diff
Archive of layout-test-results from ews105 for mac-highsierra-wk2 (2.76 MB, application/zip)
2019-03-14 17:49 PDT, EWS Watchlist
no flags Details
Archive of layout-test-results from ews124 for ios-simulator-wk2 (17.53 MB, application/zip)
2019-03-14 19:30 PDT, EWS Watchlist
no flags Details
Patch (28.26 KB, patch)
2019-03-15 10:53 PDT, Chris Dumez
no flags Details | Formatted Diff | Diff
Patch (34.51 KB, patch)
2019-03-15 11:09 PDT, Chris Dumez
no flags Details | Formatted Diff | Diff
Archive of layout-test-results from ews106 for mac-highsierra-wk2 (2.64 MB, application/zip)
2019-03-15 12:05 PDT, EWS Watchlist
no flags Details
Patch (35.04 KB, patch)
2019-03-15 13:59 PDT, Chris Dumez
no flags Details | Formatted Diff | Diff
Patch (35.06 KB, patch)
2019-03-15 14:10 PDT, Chris Dumez
no flags Details | Formatted Diff | Diff
Archive of layout-test-results from ews106 for mac-highsierra-wk2 (2.69 MB, application/zip)
2019-03-15 15:41 PDT, EWS Watchlist
no flags Details
Archive of layout-test-results from ews126 for ios-simulator-wk2 (32.05 MB, application/zip)
2019-03-15 16:44 PDT, EWS Watchlist
no flags Details
Patch (36.52 KB, patch)
2019-03-15 17:12 PDT, Chris Dumez
no flags Details | Formatted Diff | Diff
Patch (37.16 KB, patch)
2019-03-15 18:00 PDT, Chris Dumez
no flags Details | Formatted Diff | Diff
Patch (143.66 KB, patch)
2019-03-15 21:02 PDT, Chris Dumez
no flags Details | Formatted Diff | Diff
Patch (143.66 KB, patch)
2019-03-15 21:06 PDT, Chris Dumez
no flags Details | Formatted Diff | Diff
Patch (143.95 KB, patch)
2019-03-15 21:45 PDT, Chris Dumez
no flags Details | Formatted Diff | Diff
Archive of layout-test-results from ews106 for mac-highsierra-wk2 (3.05 MB, application/zip)
2019-03-15 22:43 PDT, EWS Watchlist
no flags Details
Patch (157.33 KB, patch)
2019-03-17 20:53 PDT, Chris Dumez
no flags Details | Formatted Diff | Diff
Patch (157.69 KB, patch)
2019-03-17 21:02 PDT, Chris Dumez
no flags Details | Formatted Diff | Diff
Patch (159.65 KB, patch)
2019-03-18 11:31 PDT, Chris Dumez
no flags Details | Formatted Diff | Diff
Archive of layout-test-results from ews113 for mac-highsierra (2.28 MB, application/zip)
2019-03-18 13:09 PDT, EWS Watchlist
no flags Details

Note You need to log in before you can comment on or make changes to this bug.
Description Chris Dumez 2019-03-14 13:38:58 PDT
Delay WebProcess launch until a load is triggered in a WebView instead of launching it as soon as the Web view is created.
This would allow leveraging the WebProcessCache given that we would know then which registrable domain is going to be loaded in the process.
Comment 1 Chris Dumez 2019-03-14 13:39:14 PDT
<rdar://problem/48126013>
Comment 2 Chris Dumez 2019-03-14 16:07:21 PDT
Created attachment 364710 [details]
WIP Patch
Comment 3 Chris Dumez 2019-03-14 16:26:43 PDT
Created attachment 364713 [details]
Patch
Comment 4 Chris Dumez 2019-03-14 16:39:30 PDT
Created attachment 364717 [details]
Patch
Comment 5 Chris Dumez 2019-03-14 16:44:04 PDT
Created attachment 364718 [details]
Patch
Comment 6 EWS Watchlist 2019-03-14 17:49:27 PDT
Comment on attachment 364718 [details]
Patch

Attachment 364718 [details] did not pass mac-wk2-ews (mac-wk2):
Output: https://webkit-queues.webkit.org/results/11510381

New failing tests:
fast/text/international/system-language/declarative-language.html
imported/w3c/web-platform-tests/html/browsers/the-window-object/security-window/window-security.sub.html
fast/dom/Window/showModalDialog-mandatory-parameter.html
fast/dom/Window/window-function-name-getter-precedence.html
fast/dom/Window/window-function-frame-getter-precedence.html
fast/dom/Window/delete-operations.html
http/tests/security/cross-frame-access-call.html
js/dom/function-length.html
http/wpt/mediarecorder/MediaRecorder-AV-audio-video-dataavailable.html
Comment 7 EWS Watchlist 2019-03-14 17:49:29 PDT
Created attachment 364736 [details]
Archive of layout-test-results from ews105 for mac-highsierra-wk2

The attached test failures were seen while running run-webkit-tests on the mac-wk2-ews.
Bot: ews105  Port: mac-highsierra-wk2  Platform: Mac OS X 10.13.6
Comment 8 EWS Watchlist 2019-03-14 19:30:38 PDT
Comment on attachment 364718 [details]
Patch

Attachment 364718 [details] did not pass ios-sim-ews (ios-simulator-wk2):
Output: https://webkit-queues.webkit.org/results/11511609

New failing tests:
fast/visual-viewport/ios/min-scale-greater-than-one.html
fast/css/preserve-user-specified-zoom-level-on-reload.html
platform/ios/ios/fast/coordinates/inner-window-sizes-quirks.html
fast/dom/Window/window-function-name-getter-precedence.html
platform/ipad/fast/viewport/empty-meta.html
fast/viewport/ios/use-minimum-device-width-for-page-without-viewport-meta.html
fast/dom/Window/showModalDialog-mandatory-parameter.html
fast/viewport/ios/viewport-minimum-and-initial-scale.html
fast/dom/Window/delete-operations.html
platform/ipad/fast/viewport/viewport-unchanged-by-minimum-effective-width-if-not-ignore-meta-viewport.html
fast/viewport/ios/constant-width-viewport-after-changing-view-scale.html
media/modern-media-controls/media-controller/ios/media-controller-scale-factor-audio.html
fast/scrolling/adjust-scroll-offset-on-zoom.html
fast/text/international/system-language/declarative-language.html
platform/ios/ios/fast/coordinates/inner-window-sizes.html
fast/viewport/ios/width-is-device-width-overflowing-body-overflow-hidden-tall.html
platform/ipad/fast/viewport/viewport-overriden-by-minimum-effective-width-if-ignore-meta-viewport.html
editing/input/ios/rtl-keyboard-input-on-focus.html
fast/viewport/ios/initial-scale-after-changing-view-scale.html
imported/w3c/web-platform-tests/html/browsers/the-window-object/security-window/window-security.sub.html
fast/dom/Window/window-function-frame-getter-precedence.html
js/dom/function-length.html
http/tests/security/cross-frame-access-call.html
media/modern-media-controls/media-controller/ios/media-controller-scale-factor.html
Comment 9 EWS Watchlist 2019-03-14 19:30:41 PDT
Created attachment 364756 [details]
Archive of layout-test-results from ews124 for ios-simulator-wk2

The attached test failures were seen while running run-webkit-tests on the ios-sim-ews.
Bot: ews124  Port: ios-simulator-wk2  Platform: Mac OS X 10.13.6
Comment 10 Chris Dumez 2019-03-15 10:53:13 PDT
Created attachment 364811 [details]
Patch
Comment 11 Chris Dumez 2019-03-15 11:09:49 PDT
Created attachment 364813 [details]
Patch
Comment 12 EWS Watchlist 2019-03-15 12:05:39 PDT
Comment on attachment 364813 [details]
Patch

Attachment 364813 [details] did not pass mac-wk2-ews (mac-wk2):
Output: https://webkit-queues.webkit.org/results/11520018

New failing tests:
fast/text/international/system-language/declarative-language.html
Comment 13 EWS Watchlist 2019-03-15 12:05:41 PDT
Created attachment 364820 [details]
Archive of layout-test-results from ews106 for mac-highsierra-wk2

The attached test failures were seen while running run-webkit-tests on the mac-wk2-ews.
Bot: ews106  Port: mac-highsierra-wk2  Platform: Mac OS X 10.13.6
Comment 14 Chris Dumez 2019-03-15 13:59:44 PDT
Created attachment 364838 [details]
Patch
Comment 15 Chris Dumez 2019-03-15 14:10:08 PDT
Created attachment 364840 [details]
Patch
Comment 16 EWS Watchlist 2019-03-15 15:41:36 PDT
Comment on attachment 364840 [details]
Patch

Attachment 364840 [details] did not pass mac-wk2-ews (mac-wk2):
Output: https://webkit-queues.webkit.org/results/11522959

New failing tests:
http/wpt/mediarecorder/MediaRecorder-AV-audio-video-dataavailable.html
Comment 17 EWS Watchlist 2019-03-15 15:41:42 PDT
Created attachment 364858 [details]
Archive of layout-test-results from ews106 for mac-highsierra-wk2

The attached test failures were seen while running run-webkit-tests on the mac-wk2-ews.
Bot: ews106  Port: mac-highsierra-wk2  Platform: Mac OS X 10.13.6
Comment 18 Chris Dumez 2019-03-15 16:21:14 PDT
(In reply to Build Bot from comment #16)
> Comment on attachment 364840 [details]
> Patch
> 
> Attachment 364840 [details] did not pass mac-wk2-ews (mac-wk2):
> Output: https://webkit-queues.webkit.org/results/11522959
> 
> New failing tests:
> http/wpt/mediarecorder/MediaRecorder-AV-audio-video-dataavailable.html

Flaky test, crashes in media code.
Comment 19 EWS Watchlist 2019-03-15 16:44:45 PDT
Comment on attachment 364840 [details]
Patch

Attachment 364840 [details] did not pass ios-sim-ews (ios-simulator-wk2):
Output: https://webkit-queues.webkit.org/results/11523288

New failing tests:
editing/input/ios/rtl-keyboard-input-on-focus.html
fast/viewport/ios/initial-scale-after-changing-view-scale.html
Comment 20 EWS Watchlist 2019-03-15 16:44:48 PDT
Created attachment 364878 [details]
Archive of layout-test-results from ews126 for ios-simulator-wk2

The attached test failures were seen while running run-webkit-tests on the ios-sim-ews.
Bot: ews126  Port: ios-simulator-wk2  Platform: Mac OS X 10.13.6
Comment 21 Chris Dumez 2019-03-15 17:12:49 PDT
Created attachment 364886 [details]
Patch
Comment 22 Chris Dumez 2019-03-15 18:00:51 PDT
Created attachment 364892 [details]
Patch
Comment 23 Chris Dumez 2019-03-15 21:02:54 PDT
Created attachment 364908 [details]
Patch
Comment 24 Chris Dumez 2019-03-15 21:06:21 PDT
Created attachment 364909 [details]
Patch
Comment 25 Chris Dumez 2019-03-15 21:45:17 PDT
Created attachment 364914 [details]
Patch
Comment 26 EWS Watchlist 2019-03-15 22:43:17 PDT
Comment on attachment 364914 [details]
Patch

Attachment 364914 [details] did not pass mac-wk2-ews (mac-wk2):
Output: https://webkit-queues.webkit.org/results/11527972

New failing tests:
imported/w3c/web-platform-tests/mediacapture-record/MediaRecorder-constructor.html
Comment 27 EWS Watchlist 2019-03-15 22:43:19 PDT
Created attachment 364918 [details]
Archive of layout-test-results from ews106 for mac-highsierra-wk2

The attached test failures were seen while running run-webkit-tests on the mac-wk2-ews.
Bot: ews106  Port: mac-highsierra-wk2  Platform: Mac OS X 10.13.6
Comment 28 Chris Dumez 2019-03-15 23:16:09 PDT
Comment on attachment 364918 [details]
Archive of layout-test-results from ews106 for mac-highsierra-wk2

Flaky media recorder again.
Comment 29 Chris Dumez 2019-03-17 20:53:45 PDT
Created attachment 364998 [details]
Patch
Comment 30 EWS Watchlist 2019-03-17 20:56:21 PDT
Attachment 364998 [details] did not pass style-queue:


ERROR: Source/WebKit/Shared/API/Cocoa/RemoteObjectRegistry.mm:52:  Code inside a namespace should not be indented.  [whitespace/indent] [4]
Total errors found: 1 in 40 files


If any of these errors are false positives, please file a bug against check-webkit-style.
Comment 31 Chris Dumez 2019-03-17 21:02:26 PDT
Created attachment 365000 [details]
Patch
Comment 32 EWS Watchlist 2019-03-17 21:04:13 PDT
Attachment 365000 [details] did not pass style-queue:


ERROR: Source/WebKit/Shared/API/Cocoa/RemoteObjectRegistry.mm:52:  Code inside a namespace should not be indented.  [whitespace/indent] [4]
Total errors found: 1 in 40 files


If any of these errors are false positives, please file a bug against check-webkit-style.
Comment 33 Geoffrey Garen 2019-03-18 10:23:59 PDT
Comment on attachment 365000 [details]
Patch

View in context: https://bugs.webkit.org/attachment.cgi?id=365000&action=review

r=me

> Source/WebKit/UIProcess/WebPageProxy.cpp:3560
> +    if (!hasRunningProcess() && &process() == process().processPool().initialProcessForPages())

Maybe turn !hasRunningProces() into an ASSERT.

> Source/WebKit/UIProcess/WebProcessPool.h:167
> +    WebProcessProxy* initialProcessForPages() const { return m_initialProcessForPages; }

I think I would call this dummyProcessProxy(), or something similar. "Initial" is how its clients use it, but not really how it behaves or what it is.

Maybe also add a comment just to explain that this is a convenience object to avoid null checks, and it doesn't intend to carry any semantic meaning.
Comment 34 Chris Dumez 2019-03-18 11:31:19 PDT
Created attachment 365038 [details]
Patch
Comment 35 EWS Watchlist 2019-03-18 11:34:44 PDT
Attachment 365038 [details] did not pass style-queue:


ERROR: Source/WebKit/Shared/API/Cocoa/RemoteObjectRegistry.mm:52:  Code inside a namespace should not be indented.  [whitespace/indent] [4]
Total errors found: 1 in 40 files


If any of these errors are false positives, please file a bug against check-webkit-style.
Comment 36 EWS Watchlist 2019-03-18 13:09:14 PDT
Comment on attachment 365038 [details]
Patch

Attachment 365038 [details] did not pass mac-debug-ews (mac):
Output: https://webkit-queues.webkit.org/results/11552925

New failing tests:
http/tests/security/cross-origin-worker-indexeddb.html
Comment 37 EWS Watchlist 2019-03-18 13:09:16 PDT
Created attachment 365046 [details]
Archive of layout-test-results from ews113 for mac-highsierra

The attached test failures were seen while running run-webkit-tests on the mac-debug-ews.
Bot: ews113  Port: mac-highsierra  Platform: Mac OS X 10.13.6
Comment 38 Chris Dumez 2019-03-18 13:10:50 PDT
Comment on attachment 365046 [details]
Archive of layout-test-results from ews113 for mac-highsierra

Cannot impact wk1.
Comment 39 WebKit Commit Bot 2019-03-18 13:23:54 PDT
Comment on attachment 365038 [details]
Patch

Clearing flags on attachment: 365038

Committed r243094: <https://trac.webkit.org/changeset/243094>
Comment 40 WebKit Commit Bot 2019-03-18 13:23:56 PDT
All reviewed patches have been landed.  Closing bug.
Comment 41 Truitt Savell 2019-03-18 15:40:17 PDT
The changes in https://trac.webkit.org/changeset/243094/webkit

appears to have broken media/track/track-in-band-style.html

History:
https://webkit-test-results.webkit.org/dashboards/flakiness_dashboard.html#showAllRuns=true&tests=media%2Ftrack%2Ftrack-in-band-style.html

Diff:
--- /Volumes/Data/slave/mojave-release-tests-wk2/build/layout-test-results/media/track/track-in-band-style-expected.txt
+++ /Volumes/Data/slave/mojave-release-tests-wk2/build/layout-test-results/media/track/track-in-band-style-actual.txt
@@ -14,6 +14,6 @@
 
 ** Test current cue colors
 EXPECTED (getComputedStyle(cueDisplayElement).color == 'rgb(255, 255, 255)') OK
-EXPECTED (getComputedStyle(cueNode).backgroundColor == 'rgb(0, 0, 0)') OK
+EXPECTED (getComputedStyle(cueNode).backgroundColor == 'rgb(0, 0, 0)'), OBSERVED 'rgba(0, 0, 0, 0)' FAIL
 END OF TEST
 

I reproduced this on 243094 and saw no failures when running it on 243092. 243093 is a versioning patch.
Comment 42 Chris Dumez 2019-03-18 16:26:57 PDT
(In reply to Truitt Savell from comment #41)
> The changes in https://trac.webkit.org/changeset/243094/webkit
> 
> appears to have broken media/track/track-in-band-style.html
> 
> History:
> https://webkit-test-results.webkit.org/dashboards/flakiness_dashboard.
> html#showAllRuns=true&tests=media%2Ftrack%2Ftrack-in-band-style.html
> 
> Diff:
> ---
> /Volumes/Data/slave/mojave-release-tests-wk2/build/layout-test-results/media/
> track/track-in-band-style-expected.txt
> +++
> /Volumes/Data/slave/mojave-release-tests-wk2/build/layout-test-results/media/
> track/track-in-band-style-actual.txt
> @@ -14,6 +14,6 @@
>  
>  ** Test current cue colors
>  EXPECTED (getComputedStyle(cueDisplayElement).color == 'rgb(255, 255,
> 255)') OK
> -EXPECTED (getComputedStyle(cueNode).backgroundColor == 'rgb(0, 0, 0)') OK
> +EXPECTED (getComputedStyle(cueNode).backgroundColor == 'rgb(0, 0, 0)'),
> OBSERVED 'rgba(0, 0, 0, 0)' FAIL
>  END OF TEST
>  
> 
> I reproduced this on 243094 and saw no failures when running it on 243092.
> 243093 is a versioning patch.

EWS was green and the tests were passing locally so this is odd. I am investigating...
Comment 43 Chris Dumez 2019-03-18 16:34:54 PDT
(In reply to Chris Dumez from comment #42)
> (In reply to Truitt Savell from comment #41)
> > The changes in https://trac.webkit.org/changeset/243094/webkit
> > 
> > appears to have broken media/track/track-in-band-style.html
> > 
> > History:
> > https://webkit-test-results.webkit.org/dashboards/flakiness_dashboard.
> > html#showAllRuns=true&tests=media%2Ftrack%2Ftrack-in-band-style.html
> > 
> > Diff:
> > ---
> > /Volumes/Data/slave/mojave-release-tests-wk2/build/layout-test-results/media/
> > track/track-in-band-style-expected.txt
> > +++
> > /Volumes/Data/slave/mojave-release-tests-wk2/build/layout-test-results/media/
> > track/track-in-band-style-actual.txt
> > @@ -14,6 +14,6 @@
> >  
> >  ** Test current cue colors
> >  EXPECTED (getComputedStyle(cueDisplayElement).color == 'rgb(255, 255,
> > 255)') OK
> > -EXPECTED (getComputedStyle(cueNode).backgroundColor == 'rgb(0, 0, 0)') OK
> > +EXPECTED (getComputedStyle(cueNode).backgroundColor == 'rgb(0, 0, 0)'),
> > OBSERVED 'rgba(0, 0, 0, 0)' FAIL
> >  END OF TEST
> >  
> > 
> > I reproduced this on 243094 and saw no failures when running it on 243092.
> > 243093 is a versioning patch.
> 
> EWS was green and the tests were passing locally so this is odd. I am
> investigating...

It does not reproduce locally. Also note that 'rgb(0, 0, 0)') and 'rgba(0, 0, 0, 0)' are not terribly different. They are still the same color.
Comment 44 Chris Dumez 2019-03-18 16:44:18 PDT
(In reply to Chris Dumez from comment #43)
> (In reply to Chris Dumez from comment #42)
> > (In reply to Truitt Savell from comment #41)
> > > The changes in https://trac.webkit.org/changeset/243094/webkit
> > > 
> > > appears to have broken media/track/track-in-band-style.html
> > > 
> > > History:
> > > https://webkit-test-results.webkit.org/dashboards/flakiness_dashboard.
> > > html#showAllRuns=true&tests=media%2Ftrack%2Ftrack-in-band-style.html
> > > 
> > > Diff:
> > > ---
> > > /Volumes/Data/slave/mojave-release-tests-wk2/build/layout-test-results/media/
> > > track/track-in-band-style-expected.txt
> > > +++
> > > /Volumes/Data/slave/mojave-release-tests-wk2/build/layout-test-results/media/
> > > track/track-in-band-style-actual.txt
> > > @@ -14,6 +14,6 @@
> > >  
> > >  ** Test current cue colors
> > >  EXPECTED (getComputedStyle(cueDisplayElement).color == 'rgb(255, 255,
> > > 255)') OK
> > > -EXPECTED (getComputedStyle(cueNode).backgroundColor == 'rgb(0, 0, 0)') OK
> > > +EXPECTED (getComputedStyle(cueNode).backgroundColor == 'rgb(0, 0, 0)'),
> > > OBSERVED 'rgba(0, 0, 0, 0)' FAIL
> > >  END OF TEST
> > >  
> > > 
> > > I reproduced this on 243094 and saw no failures when running it on 243092.
> > > 243093 is a versioning patch.
> > 
> > EWS was green and the tests were passing locally so this is odd. I am
> > investigating...
> 
> It does not reproduce locally. Also note that 'rgb(0, 0, 0)') and 'rgba(0,
> 0, 0, 0)' are not terribly different. They are still the same color.

This seems to rely on Color::cssText() so Color::isOpaque() returns false and we use rgba() instead of rgb() format.
Comment 45 Chris Dumez 2019-03-18 16:51:10 PDT
(In reply to Chris Dumez from comment #44)
> (In reply to Chris Dumez from comment #43)
> > (In reply to Chris Dumez from comment #42)
> > > (In reply to Truitt Savell from comment #41)
> > > > The changes in https://trac.webkit.org/changeset/243094/webkit
> > > > 
> > > > appears to have broken media/track/track-in-band-style.html
> > > > 
> > > > History:
> > > > https://webkit-test-results.webkit.org/dashboards/flakiness_dashboard.
> > > > html#showAllRuns=true&tests=media%2Ftrack%2Ftrack-in-band-style.html
> > > > 
> > > > Diff:
> > > > ---
> > > > /Volumes/Data/slave/mojave-release-tests-wk2/build/layout-test-results/media/
> > > > track/track-in-band-style-expected.txt
> > > > +++
> > > > /Volumes/Data/slave/mojave-release-tests-wk2/build/layout-test-results/media/
> > > > track/track-in-band-style-actual.txt
> > > > @@ -14,6 +14,6 @@
> > > >  
> > > >  ** Test current cue colors
> > > >  EXPECTED (getComputedStyle(cueDisplayElement).color == 'rgb(255, 255,
> > > > 255)') OK
> > > > -EXPECTED (getComputedStyle(cueNode).backgroundColor == 'rgb(0, 0, 0)') OK
> > > > +EXPECTED (getComputedStyle(cueNode).backgroundColor == 'rgb(0, 0, 0)'),
> > > > OBSERVED 'rgba(0, 0, 0, 0)' FAIL
> > > >  END OF TEST
> > > >  
> > > > 
> > > > I reproduced this on 243094 and saw no failures when running it on 243092.
> > > > 243093 is a versioning patch.
> > > 
> > > EWS was green and the tests were passing locally so this is odd. I am
> > > investigating...
> > 
> > It does not reproduce locally. Also note that 'rgb(0, 0, 0)') and 'rgba(0,
> > 0, 0, 0)' are not terribly different. They are still the same color.
> 
> This seems to rely on Color::cssText() so Color::isOpaque() returns false
> and we use rgba() instead of rgb() format.

Ok, so if I run this test in a loop 100 times with -gf, then it fails some of the runs. This test is flaky. Given the nature of my change, I think I merely impacted the timing and made the test flakier.
Now that I can reproduce, I will see if I can deflake the test.
Comment 46 Chris Dumez 2019-03-18 16:57:57 PDT
(In reply to Chris Dumez from comment #45)
> (In reply to Chris Dumez from comment #44)
> > (In reply to Chris Dumez from comment #43)
> > > (In reply to Chris Dumez from comment #42)
> > > > (In reply to Truitt Savell from comment #41)
> > > > > The changes in https://trac.webkit.org/changeset/243094/webkit
> > > > > 
> > > > > appears to have broken media/track/track-in-band-style.html
> > > > > 
> > > > > History:
> > > > > https://webkit-test-results.webkit.org/dashboards/flakiness_dashboard.
> > > > > html#showAllRuns=true&tests=media%2Ftrack%2Ftrack-in-band-style.html
> > > > > 
> > > > > Diff:
> > > > > ---
> > > > > /Volumes/Data/slave/mojave-release-tests-wk2/build/layout-test-results/media/
> > > > > track/track-in-band-style-expected.txt
> > > > > +++
> > > > > /Volumes/Data/slave/mojave-release-tests-wk2/build/layout-test-results/media/
> > > > > track/track-in-band-style-actual.txt
> > > > > @@ -14,6 +14,6 @@
> > > > >  
> > > > >  ** Test current cue colors
> > > > >  EXPECTED (getComputedStyle(cueDisplayElement).color == 'rgb(255, 255,
> > > > > 255)') OK
> > > > > -EXPECTED (getComputedStyle(cueNode).backgroundColor == 'rgb(0, 0, 0)') OK
> > > > > +EXPECTED (getComputedStyle(cueNode).backgroundColor == 'rgb(0, 0, 0)'),
> > > > > OBSERVED 'rgba(0, 0, 0, 0)' FAIL
> > > > >  END OF TEST
> > > > >  
> > > > > 
> > > > > I reproduced this on 243094 and saw no failures when running it on 243092.
> > > > > 243093 is a versioning patch.
> > > > 
> > > > EWS was green and the tests were passing locally so this is odd. I am
> > > > investigating...
> > > 
> > > It does not reproduce locally. Also note that 'rgb(0, 0, 0)') and 'rgba(0,
> > > 0, 0, 0)' are not terribly different. They are still the same color.
> > 
> > This seems to rely on Color::cssText() so Color::isOpaque() returns false
> > and we use rgba() instead of rgb() format.
> 
> Ok, so if I run this test in a loop 100 times with -gf, then it fails some
> of the runs. This test is flaky. Given the nature of my change, I think I
> merely impacted the timing and made the test flakier.
> Now that I can reproduce, I will see if I can deflake the test.

Tracking this flaky test via https://bugs.webkit.org/show_bug.cgi?id=195922.